local Mod = ...


-- TESTING CHEAT: Change the starting Village Center inventory
-- Mod:override({
	-- Id = "DEFAULT_VILLAGE_CENTER_INVENTORY",
	-- Collection = {
        -- {Resource = "WOOD", Quantity = 100000}, 
        -- {Resource = "STONE", Quantity = 100000}, 
        -- {Resource = "PLANK", Quantity = 100000},
        -- {Resource = "TOOL", Quantity = 100000},
        -- {Resource = "GOLD", Quantity = 100000}
    -- }
-- })



-- Assets
-------------------------------------------------------------------------------------
Mod:registerAssetProcessor("models/WildBerries.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })
Mod:registerAssetId("models/WildBerries.fbx/Prefab/BerryHutPart01", "PREFAB_BERRYHUT01")
-- Mod:registerAssetId("models/WildBerries.fbx/Prefab/BerryBushPart01", "PREFAB_BERRYBUSH01")
Mod:registerAssetId("models/WildBerries.fbx/Prefab/BerryBushPart02", "PREFAB_BERRYBUSH02")

Mod:registerAssetId("models/WildBerries.fbx/Prefab/HatPart01", "PREFAB_HAT_BERRYPICKER1")
Mod:registerAssetId("models/WildBerries.fbx/Prefab/HatPart02", "PREFAB_HAT_BERRYPICKER2")

-- Mod:registerAssetId("models/WildBerries.fbx/Materials/Material.Redberries", "REDBERRIES")
Mod:registerAssetId("models/WildBerries.fbx/Materials/Material.Blueberries", "BLUEBERRIES")
-- Mod:registerAssetId("models/WildBerries.fbx/Materials/Material.Bush01", "BUSH01")
Mod:registerAssetId("models/WildBerries.fbx/Materials/Material.Wicker", "WICKER")

-- Mod:override({
    -- Id = "REDBERRIES",
	-- HasAlphaTest = true,
	-- BackFaceVisible = true
-- })

Mod:override({
    Id = "BLUEBERRIES",
	HasAlphaTest = true,
	BackFaceVisible = true
})

-- Mod:override({
    -- Id = "BUSH01",
	-- HasAlphaTest = true,
	-- BackFaceVisible = true
-- })

Mod:override({
    Id = "WICKER",
	HasAlphaTest = true,
	BackFaceVisible = true
})


-- Resources: Berry Bush
-------------------------------------------------------------------------------------
-- Mod:registerAssetId("icons/berrybush01.png", "ICON_BERRYBUSH01", "ATLAS_CELL")

-- Mod:register({
	-- DataType = "RESOURCE",
	-- Id = "RESOURCE_BERRYBUSH01",
	-- ResourceName = "RESOURCE_BERRYBUSH01_NAME",
	-- Icon = "ICON_BERRYBUSH01",
	-- ResourceTypeList = { "FOOD", "GRANARY" },
	-- IsTradable = true,
	-- ResourceLayoutType = "CRATES",
	-- DisplayInInventory = true,
	-- VillagerBuyingPrice = { Resource = "GOLD", Quantity = 1 }
-- })


-- Monument: Berry Huts
-------------------------------------------------------------------------------------
Mod:register({
	DataType = "BUILDING", 
	Id = "BUILDING_WILDBERRIES",
	Name = "BUILDING_WILDBERRIES_NAME",
	Description = "BUILDING_WILDBERRIES_DESC",
	BuildingType = "FOOD_PRODUCTION",
	AssetCoreBuildingPart = "BUILDING_PART_MONUMENT_POLE",
	IsEditable = true,
	BuildingPartSetList = {
		{
			Name = "BUILDING_SET_WILDBERRIES",
			BuildingPartList = { 
				"BERRYHUT01_PART",
			}
		},		
    }
})


-- Building Part: Berry Hut 01
-------------------------------------------------------------------------------------
Mod:register({
	DataType = "BUILDING_PART",
	Id = "BERRYHUT01_PART",
	Name = "BERRYHUT01_PART_NAME",
	Description = "BERRYHUT01_PART_DESC",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_BERRYHUT01"
	},
	-- ConstructionVisual = "PREFAB_CONSTR_BUILDING_PART_MARKET01",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {5.0, 4.0}, {0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true } 
			},
		}
	},
	AssetBuildingFunction = "BUILDING_FUNCTION_WILDBERRIES_BERRYHUT01",
	Cost = {
		BuildRightTaxes = {	{ Resource = "GOLD", Quantity = 1 } },
		UpkeepCost = { { Resource = "GOLD", Quantity = 1 } },
		RessourcesNeeded = {
            { Resource = "WOOD", Quantity = 10 },
            { Resource = "TOOL", Quantity = 1 }
		}
	}
})


-- Building Function: Berry Hut 01 -------------------------------------------------------------------------------------
Mod:register({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "BUILDING_FUNCTION_WILDBERRIES_BERRYHUT01",
    Name = "BUILDING_PART_WILDBERRIES_BERRYHUT01_NAME",
    WorkerCapacity = 2,
    RelatedJob = { 
        Job = "BERRY_PICKER", --"GATHERER", 
        Behavior = "BEHAVIOR_PRODUCE_TREE_COLLECTOR" --"BEHAVIOR_GATHER"
	},--[[
	InputInventoryCapacity = {
		{ Resource = "BERRIES", Quantity = 1 },
	},]]--
    ResourceListNeeded = {
		{ Resource = "BERRIES", Quantity = 1 },
	},
	ResourceProduced = {
		{ Resource = "BERRIES", Quantity = 1 },
	}
})

Mod:register({
	DataType = "JOB",
	Id = "BERRY_PICKER",
	JobName = "BERRY_PICKER_NAME",
	JobDescription = "BERRY_PICKER_DESC",
	IsLockedByDefault = false,
    ProductionDelay = 5, -- set this as you wish for balancing
	AssetJobProgression = "DEFAULT_JOB_PROGRESSION",
	CharacterSetup = {
        DataType = "CHARACTER_SETUP",
        WalkAnimation = "WALKING",
		IdleAnimation = "GATHER",
		FemaleHatList = {
            "PREFAB_HAT_BERRYPICKER1",
        }, 
        MaleHatList = {
            "PREFAB_HAT_BERRYPICKER2",
        }
	}
})

Mod:override({
    Id = "NEWCOMER",
    CompatibleJobList = {
        Action = "APPEND",
        "BERRY_PICKER"
    }
})

Mod:override({
    Id = "SERF",
    CompatibleJobList = {
        Action = "APPEND",
        "BERRY_PICKER"
    }
})


-- Resource Container: Bush01  -------------------------------------------------------------------------------------
-- Mod:registerPrefabComponent( "models/WildBerries.fbx/Prefab/BerryBushPart01", {
    -- DataType = "COMP_RESOURCE_CONTAINER",
    -- ResourceData = "BERRIES",

    -- -- IsReplenishable = false,
    -- -- ReplenishDurationInDays = 7,
    -- -- ReplenishQuantity = 2,
    -- ResourceValue = 1.0, -- how many are gathered with each pick
    -- AvailableQuantity = 1, -- maximum container stock
    -- Radius = 2.0, -- distance from container that the villager will stand to pick
    -- IsDestroyWhenEmpty = true

-- })


-- Resource Container: Bush02  -------------------------------------------------------------------------------------
Mod:registerPrefabComponent( "models/WildBerries.fbx/Prefab/BerryBushPart02", {
    DataType = "COMP_RESOURCE_CONTAINER",
    ResourceData = "BERRIES",

    -- IsReplenishable = false,
    -- ReplenishDurationInDays = 7,
    -- ReplenishQuantity = 2,
    ResourceValue = 1.0, -- how many are gathered with each pick
    AvailableQuantity = 1, -- maximum container stock
    Radius = 2.0, -- distance from container that the villager will stand to pick
    IsDestroyWhenEmpty = true

})


Mod:override({
  Id = "DEFAULT_BALANCING",
  StartingTileResourceRequirement = {
    {Resource = "STONE", Quantity = 1},
    {Resource = "WOOD", Quantity = 100}
  }
})


-- Paths: Berry Hut -------------------------------------------------------------------------------------
Mod:registerAssetId("models/WildBerries.fbx/Prefab/BerryHutPart01/PATH_A_1", "PATH_BERRHUT01_A")
Mod:registerAssetId("models/WildBerries.fbx/Prefab/BerryHutPart01/PATH_B_1", "PATH_BERRHUT01_B")

Mod:registerPrefabComponent("models/WildBerries.fbx/Prefab/BerryHutPart01", {
    DataType = "COMP_BUILDING_PART",
    PathList = {
        {
            PathType = BUILDING_PATH_TYPE.DEFAULT,
            WayPointList = { "PATH_BERRHUT01_A"}
        },
        {
            PathType = BUILDING_PATH_TYPE.DEFAULT,
            WayPointList = { "PATH_BERRHUT01_B" }
        },
    }
})


-- Grounding
-----------------------------------------------------------------------------------
Mod:registerPrefabComponent("models/WildBerries.fbx/Prefab/BerryHutPart01/Basket", {DataType = "COMP_GROUNDED"})
Mod:registerPrefabComponent("models/WildBerries.fbx/Prefab/BerryHutPart01/BoxSmallBerries", {DataType = "COMP_GROUNDED"})
Mod:registerPrefabComponent("models/WildBerries.fbx/Prefab/BerryHutPart01/Hat.002", {DataType = "COMP_GROUNDED"})
Mod:registerPrefabComponent("models/WildBerries.fbx/Prefab/BerryHutPart01/BoxSmallBerries.005", {DataType = "COMP_GROUNDED"})
Mod:registerPrefabComponent("models/WildBerries.fbx/Prefab/BerryHutPart01/Basket.009", {DataType = "COMP_GROUNDED"})
Mod:registerPrefabComponent("models/WildBerries.fbx/Prefab/BerryHutPart01/BoxSmallBerries.003", {DataType = "COMP_GROUNDED"})
Mod:registerPrefabComponent("models/WildBerries.fbx/Prefab/BerryHutPart01/Basket.004", {DataType = "COMP_GROUNDED"})
Mod:registerPrefabComponent("models/WildBerries.fbx/Prefab/BerryHutPart01/Basket.002", {DataType = "COMP_GROUNDED"})
